#include "Share.h"
#include <time.h>
#include <Winbase.h>

class THITime:public TDebug
{
   private:
   public:
       BYTE _prop_Time_Date;
       string _prop_newTimeZoneInformation;
       THI_Event *_data_newHours;
       THI_Event *_data_newMinute;
       THI_Event *_data_newSecond;
       THI_Event *_data_newTimeZoneInformation;
        
     HI_WORK_LOC(THITime,_work_doTimeDate)
     {    
         SYSTEMTIME newTime;
            GetLocalTime(&newTime);
           if  (_prop_Time_Date==0)
           {
            newTime.wHour= ReadInteger(_Data,_data_newHours,0);
            newTime.wMinute=ReadInteger(_Data,_data_newMinute,0);
            newTime.wSecond=ReadInteger(_Data,_data_newSecond,0);
            }
           else
            {
            newTime.wYear=ReadInteger(_Data,_data_newHours,0);
            newTime.wMonth=ReadInteger(_Data,_data_newMinute,0);
            newTime.wDay=ReadInteger(_Data,_data_newSecond,0);
            }
           SetLocalTime(&newTime);
       }
       
    HI_WORK_LOC(THITime,_work_doTimeZoneInformation)
	   {
	       TIME_ZONE_INFORMATION TimeZoneInformation;
	       ZeroMemory(&TimeZoneInformation, sizeof(TimeZoneInformation));
	       string del = L"/";
	       string si = ReadString(_Data,_data_newTimeZoneInformation,_prop_newTimeZoneInformation);
	       string sLeft=si.GetTok(del);
	       _tcscpy(TimeZoneInformation.StandardName,sLeft.c_str());
	       long bias=StrToInt(si);
	       TimeZoneInformation.Bias=bias;
	    if (SetTimeZoneInformation(&TimeZoneInformation )==0)  
	       MessageBox(NULL,L"Error",PChar(IntToStr(GetLastError())),MB_OK);
	   } 
	     
    HI_WORK(_var_FormatTime)
         {
       SYSTEMTIME systemTime;
       GetLocalTime(&systemTime);
       char h1=(_Data,systemTime.wHour/10+48);
       char h2=(_Data,systemTime.wHour%10+48);
       char min1=(_Data,systemTime.wMinute/10+48);
       char min2=(_Data,systemTime.wMinute%10+48);
       char sk1=(_Data,systemTime.wSecond/10+48);
       char sk2=(_Data,systemTime.wSecond%10+48);
       int y1 = ((_Data,systemTime.wYear-2000)/10+48);
       int y2 = ((_Data,systemTime.wYear-2000)%10+48);
       int mth1=(_Data,systemTime.wMonth/10+48 );
       int mth2=(_Data,systemTime.wMonth%10+48 );
       int day1=(_Data,systemTime.wDay/10+48);
       int day2=(_Data,systemTime.wDay%10+48);
                 string sp = L""; 
                 string fu = L":";
                 string more = L"*";
                 string pnt = L".";
                 string mill = L"20";
    string fr  = sp+h1+h2+fu+min1+min2+fu+sk1+sk2+more+day1+day2+pnt+mth1+mth2+pnt+mill+y1+y2 ;
       
              CreateData(_Data,fr);
            }
     
    HI_WORK_LOC(THITime,_var_Hours)
      {
           SYSTEMTIME systemTime;
         GetLocalTime(&systemTime);
      char h1=(_Data,systemTime.wHour/10+48);
      char h2=(_Data,systemTime.wHour%10+48);
      int h3= (_Data,systemTime.wYear);
              string hu = L"";
              string hr = hu + h1 + h2;
              if  (_prop_Time_Date==0)
             CreateData(_Data,hr);
             else CreateData(_Data,h3);         
      }
      
      HI_WORK_LOC(THITime,_var_Minute)
      {  
        SYSTEMTIME systemTime;
        GetLocalTime(&systemTime);
        char min1=(_Data,systemTime.wMinute/10+48);
        char min2=(_Data,systemTime.wMinute%10+48);
        int mn3=(_Data,systemTime.wMonth );
              string mu = L"";
              string mn = mu + min1 + min2;
              if  (_prop_Time_Date==0)
             CreateData(_Data,mn);
             else CreateData(_Data,mn3); 
      }
      
       HI_WORK_LOC(THITime,_var_Second)  
       {  
        SYSTEMTIME systemTime;
        GetLocalTime(&systemTime);
        char sk1=(_Data,systemTime.wSecond/10+48);
        char sk2=(_Data,systemTime.wSecond%10+48);
        int sk3=(_Data,systemTime.wDay);
              string su = L"";
              string sk  = su + sk1 + sk2;
              if  (_prop_Time_Date==0)
         CreateData(_Data,sk);
             else CreateData(_Data,sk3); 
           }
           
        HI_WORK_LOC(THITime,_var_Milliseconds)  
       {  
        SYSTEMTIME systemTime;
        GetLocalTime(&systemTime);
        char ms1=(_Data,systemTime.wMilliseconds/10+48);
        char ms2=(_Data,systemTime.wMilliseconds%10+48);
        int ms3=(_Data,systemTime.wDayOfWeek);
              string su = L"";
              string sk  = su + ms1 + ms2;
              if  (_prop_Time_Date==0)
         CreateData(_Data,sk);
             else CreateData(_Data,ms3); 
           }
              
       HI_WORK( _var_TimeZoneInformation) 
	    {
	       TIME_ZONE_INFORMATION TimeZoneInformation;
	      if (GetTimeZoneInformation(&TimeZoneInformation )!=TIME_ZONE_ID_UNKNOWN)
	           {
	            string name=TimeZoneInformation.StandardName;
	            int bias=TimeZoneInformation.Bias;
			    string out=name+_his("/")+IntToStr(bias);
	            CreateData(_Data,out);
				}
		}   
}; 

//#############################################################################
 
 